<?php
class MaroyakaWebClapRankingWidget extends WP_Widget {
	function __construct() {
		parent::__construct(
			'MaroyakaWebClapRankingWidget' ,
			'WEB拍手ランキング' ,
			array(
				'classname' => 'maroyaka-webclap-ranking-widget', 
				'description' => 'まろやかWEB拍手 for WordPressの拍手ページをランキング形式で表示します'
			)
		);
	}

	function form($instance) {
		$default = array(
			'title' => 'WEB拍手ランキング',
			'maxview' => 10,
			'coloring' => 'default',
			'period' => 1,
			'view_id' => 0,
			'view_eyecatch' => 0,
		);
		$instance = wp_parse_args((array) $instance, $default);
		?>
		<div class="mwc-widget">
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>">タイトル：</label>
				<input type="text" class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" value="<?php echo $instance['title']; ?>" >
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('maxview'); ?>">最大表示順位：</label>
				<input type="number" size="3" id="<?php echo $this->get_field_id('maxview'); ?>" name="<?php echo $this->get_field_name('maxview'); ?>" value="<?php echo $instance['maxview']; ?>" >
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('period'); ?>">
				<input type="checkbox" id="<?php echo $this->get_field_id('period'); ?>"  name="<?php echo $this->get_field_name('period'); ?>" value="1" <?php checked($instance['period'], 1); ?>> 期間を選択可能にする</label>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('view_id'); ?>">
				<input type="checkbox" id="<?php echo $this->get_field_id('view_id'); ?>"  name="<?php echo $this->get_field_name('view_id'); ?>" value="1" <?php checked($instance['view_id'], 1); ?>> 記事IDを表示する</label>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('view_eyecatch'); ?>">
				<input type="checkbox" id="<?php echo $this->get_field_id('view_eyecatch'); ?>"  name="<?php echo $this->get_field_name('view_eyecatch'); ?>" value="1" <?php checked($instance['view_eyecatch'], 1); ?>> アイキャッチを表示する</label>
			</p>
			<?php
			$f_radio_id= $this->get_field_id('coloring');
			$f_radio_name = $this->get_field_name('coloring');
			$data = array(
				'default',
				'primary',
				'success',
				'info',
				'warning',
				'danger',
			);
			?>
			<p>
				<label for="<?php echo $f_radio_id; ?>">カラーリング：</label><br />
				<?php foreach ($data as $k => $v) :
					$lk = $f_radio_id. '_'. $k;
					?>
					<label for ="<?php echo $lk; ?>">
						<input type="radio" name="<?php echo $f_radio_name; ?>" id="<?php echo $lk; ?>" value="<?php echo $v; ?>" <?php checked($instance['coloring'], $v); ?>><span class="text-<?php echo $v; ?>">■</span>
					</label>&nbsp;
					<?php  ?>
				<?php endforeach; ?>
			</p>
		</div>
		<?php
	}

	function update($new_instance, $old_instance) {
		$instance = $old_instance;
		$instance['title'] = esc_attr($new_instance['title']);
		$instance['maxview'] = is_numeric($new_instance['maxview']) ? $new_instance['maxview'] : 10;
		$instance['coloring'] = esc_attr($new_instance['coloring']);
		$instance['period'] = ($new_instance['period'] == 1) ? 1 : '';
		$instance['view_eyecatch'] = ($new_instance['view_eyecatch'] == 1) ? 1 : '';
		$instance['view_id'] = ($new_instance['view_id'] == 1) ? 1 : '';
		return $instance;
	}

	function widget($args, $instance) {
		extract($args);

		$ranking = get_option('mwc_ranking');
		if (!isset($ranking['time']) || $ranking['time'] < date_i18n('U')) {
			global $wpdb;
			$prefix = MaroyakaWebClap::get_prefix();

			$sql = "SELECT cid.count, cid.post_id, cid.label".
							" FROM ". $prefix. MWC_DB_TABLE_ID. " AS cid".
							" LEFT JOIN ". $wpdb->posts. " post".
								" ON cid.post_id = post.ID".
							" LEFT JOIN ". $wpdb->postmeta. " meta".
								" ON cid.post_id = meta.post_id".
									" AND meta.meta_key = 'mwc_deny_btn'".
							" WHERE post.post_status = 'publish'".
								" AND IFNULL(meta.meta_value, 0) != '1'".
							" ORDER BY cid.count DESC";

			$clap_list = $wpdb->get_results($sql, ARRAY_A);

			$ranking_data = array();
			$rank = 0; $prev = -1; $i = 0; $last = count($clap_list);
			foreach ($clap_list as &$row) {
				$i++;
				if ($prev !== $row['count']) $rank = $i;
				if ($rank > $instance['maxview']) break;
				$prev = $row['count'];
				$label = esc_attr($row['label']);
				if ($instance['view_id'] == 1) {
					$label = '('. $row['post_id']. ') '. $label;
				}
				if ($instance['view_eyecatch'] == 1) {
					if (!empty($label)) $label .= '<br>';
					$label .= get_the_post_thumbnail($row['post_id'], array(50, 50));
				}
				$row['label'] = $label;
				$row['page_url'] = get_permalink($row['post_id']);
				$row['rank'] = $rank;
				$ranking_data[] = $row;
			}

			$ranking = array(
				'time' => date_i18n('U') + (60 * 60),
				'data' => $ranking_data
			);
			update_option('mwc_ranking', $ranking);
		}

		echo $before_widget;

		if (!empty($instance['title'])) : ?>
			<?php echo $before_title. $instance['title']. $after_title; ?>
		<?php endif; ?>
		<?php if (!empty($instance['period'])) : ?>
			<div class="mwc-ranking-navi" data-widget-id="<?php echo $args['widget_id']; ?>" data-maxview="<?php echo $instance['maxview'] ?>">
				<div class="item active" data-toggle="mwc-ranking" data-mode="">総合</div
				>|<div class="item" data-toggle="mwc-ranking" data-mode="month"><a href="#">一ヶ月</a></div
				>|<div class="item" data-toggle="mwc-ranking" data-mode="week"><a href="#">一週</a></div
				>|<div class="item" data-toggle="mwc-ranking" data-mode="yesterday"><a href="#">昨日</a></div
				>|<div class="item" data-toggle="mwc-ranking" data-mode="today"><a href="#">今日</a></div>
			</div>
		<?php endif; ?>
		<div class="mwc-ranking-table color-<?php echo $instance['coloring']; ?>">
			<div class="thead">
				<div class="tr">
					<div class="td column-rank">順位</div>
					<div class="td column-count">拍手数</div>
					<div class="td column-label">ページ</div>
				</div>
			</div>
			<div class="tbody">
				<?php foreach ($ranking['data'] as $row) :
					?>
					<div class="tr">
						<div class="td column-rank"><?php echo $row['rank']; ?></div>
						<div class="td column-count"><?php echo $row['count']; ?></div>
						<div class="td column-label"><a href="<?php echo $row['page_url']; ?>" target="_top" title="<?php echo $row['label']; ?>"><?php
							echo $row['label'];
						?></a></div>
					</div>
				<?php endforeach; ?>
			</div>
		</div>
		<?php

		echo $after_widget;
	}
}
add_action('widgets_init', create_function('', 'return register_widget("MaroyakaWebClapRankingWidget");'));

class MaroyakaWebClapWidget extends WP_Widget {
	function __construct() {
		parent::__construct(
			'MaroyakaWebClapWidget' ,
			'WEB拍手' ,
			array(
				'classname' => 'maroyaka-webclap-widget', 
				'description' => 'まろやかWEB拍手 for WordPressの拍手を一覧表示します'
			)
		);
	}

	function form($instance) {
		$default = array(
			'title' => 'WEB拍手一覧',
			'maxview' => 5,
			'view_eyecatch' => 0
		);
		$instance = wp_parse_args((array) $instance, $default);
		?>
		<div class="mwc-widget">
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>">タイトル：</label>
				<input type="text" class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" value="<?php echo $instance['title']; ?>" >
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('maxview'); ?>">表示件数：</label>
				<input type="number" size="3" id="<?php echo $this->get_field_id('maxview'); ?>" name="<?php echo $this->get_field_name('maxview'); ?>" value="<?php echo $instance['maxview']; ?>" >
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('view_eyecatch'); ?>">
				<input type="hidden" name="<?php echo $this->get_field_name('view_eyecatch'); ?>" value="0">
				<input type="checkbox" id="<?php echo $this->get_field_id('view_eyecatch'); ?>"  name="<?php echo $this->get_field_name('view_eyecatch'); ?>" value="1" <?php checked($instance['view_eyecatch'], 1); ?>> アイキャッチを表示する</label>
			</p>
		</div>
		<?php
	}

	function widget($args, $instance) {
		extract($args);

		echo $before_widget;

		if (!empty($instance['title'])) : ?>
			<?php echo $before_title. $instance['title']. $after_title; ?>
		<?php endif;

		global $wpdb;
		$prefix = MaroyakaWebClap::get_prefix();

		$sql = "SELECT gcl.timestamp, pst.ID, pst.post_title".
						" FROM " . $prefix. MWC_DB_TABLE_CLAP. " AS gcl".
						" LEFT JOIN ". $wpdb->posts. " AS pst".
							" ON gcl.post_id = pst.ID".
						" GROUP BY gcl.ip, gcl.post_id".
						" ORDER BY gcl.timestamp DESC".
						" LIMIT 0, %d";

		$clap_list = $wpdb->get_results($wpdb->prepare($sql, $instance['maxview']), ARRAY_A);

		?>
		<div class="mwc-clap-list">
		<?php
		foreach ($clap_list as $clap) {
			?>
			<div class="clap">
				<?php if ($instance['view_eyecatch'] == 1) : ?>
					<?php echo get_the_post_thumbnail($clap['ID'], array(50, 50)) ?>
				<?php endif; ?>
				<a href="<?php the_permalink($clap['ID']); ?>"><?php echo $clap['post_title'] ?></a>が拍手されました！
				<div class="date">(<?php

				$tt = date_i18n('U') - strtotime($clap['timestamp']);
				if ($tt >= 0 && $tt < 10) {
					printf('今');
				} elseif ($tt >= 10 && $tt < 60) {
					printf('%d秒前', $tt);
				} elseif ($tt >= 60 && $tt < 3600) {
					printf('%d分前', ($tt / 60));
				} elseif ($tt >= 3600 && $tt < 86400 ) {
					printf('%d時間前', ($tt / 60 / 60));
				// } elseif ($tt >= 86400 && $tt < 2592000 ) {
				// 	$ts = sprintf('%d日前', ($tt / 60 / 60 / 24));
				} else {
					echo mysql2date( get_option( 'date_format' ), $clap['timestamp'] );
					echo mysql2date( get_option( 'time_format' ), $clap['timestamp'] );
				}

				?>)</div>
			</div>
			<?php
		}
		?></div><?php

		echo $after_widget;
	}
}
add_action('widgets_init', create_function('', 'return register_widget("MaroyakaWebClapWidget");'));
